package org.eclipse.jdt.internal.compiler.flow;

package .tmp;

import org.eclipse.jdt.internal.compiler.flow.ExceptionHandlingFlowContext;
import org.eclipse.jdt.internal.compiler.flow.FlowInfo;
import org.eclipse.jdt.internal.compiler.flow.LoopingFlowContext;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;

class EscapingExceptionCatchSite {
  final ReferenceBinding caughtException;
  
  final ExceptionHandlingFlowContext catchingContext;
  
  final FlowInfo exceptionInfo;
  
  public EscapingExceptionCatchSite(ExceptionHandlingFlowContext catchingContext, ReferenceBinding caughtException, FlowInfo exceptionInfo) {
    this.catchingContext = catchingContext;
    this.caughtException = caughtException;
    this.exceptionInfo = exceptionInfo;
  }
  
  void simulateThrowAfterLoopBack(FlowInfo flowInfo) {
    this.catchingContext.recordHandlingException(this.caughtException, 
        flowInfo.unconditionalCopy().addNullInfoFrom(this.exceptionInfo).unconditionalInits(), 
        null, 
        null, null, true);
  }
}
